diff --git a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
new file mode 100644
index 000000000..842280c2c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -0,0 +1,375 @@
+package net.minecraft.core.net.handler;
+
+import net.minecraft.core.net.packet.*;
+
+public abstract class PacketHandler
+{
+
+    public PacketHandler()
+    {
+    }
+
+    public abstract boolean isServerHandler();
+
+    public void handleMapChunk(BlockRegionUpdatePacket blockRegionUpdatePacket51Mapchunk)
+    {
+    }
+
+    public void handleInvalidPacket(Packet packet)
+    {
+    }
+
+    public void handleErrorMessage(String s, Object[] aobj)
+    {
+    }
+
+    public void handleKickDisconnect(DisconnectPacket packet255KickdisconnectPacket)
+    {
+        handleInvalidPacket(packet255KickdisconnectPacket);
+    }
+
+    public void handleLogin(LoginPacket loginPacket)
+    {
+        handleInvalidPacket(loginPacket);
+    }
+
+    public void handleFlying(MovePlayerPacket movePlayerPacket)
+    {
+        handleInvalidPacket(movePlayerPacket);
+    }
+
+    public void handleMultiBlockChange(ChunkBlocksUpdatePacket packet)
+    {
+        handleInvalidPacket(packet);
+    }
+
+    public void handleBlockDig(PlayerActionPacket playerActionPacket14Blockdig)
+    {
+        handleInvalidPacket(playerActionPacket14Blockdig);
+    }
+
+    public void handleBlockChange(BlockUpdatePacket blockchange)
+    {
+        handleInvalidPacket(blockchange);
+    }
+
+    public void handlePreChunk(ChunkVisibilityPacket packet50PrechunkVisibilityPacket)
+    {
+        handleInvalidPacket(packet50PrechunkVisibilityPacket);
+    }
+
+    public void handleNamedEntitySpawn(AddPlayerPacket addPlayerPacket20Namedentityspawn)
+    {
+        handleInvalidPacket(addPlayerPacket20Namedentityspawn);
+    }
+
+    public void handleEntity(MoveEntityPacket moveEntityPacket)
+    {
+        handleInvalidPacket(moveEntityPacket);
+    }
+
+    public void handleEntityTeleport(TeleportEntityPacket packet34EntityteleportEntityPacket)
+    {
+        handleInvalidPacket(packet34EntityteleportEntityPacket);
+    }
+
+    public void handlePlace(UseItemPacket useItemPacket)
+    {
+        handleInvalidPacket(useItemPacket);
+    }
+
+    public void handleBlockItemSwitch(SetCarriedItemPacket packet16blockitemswitch)
+    {
+        handleInvalidPacket(packet16blockitemswitch);
+    }
+
+    public void handleDestroyEntity(RemoveEntityPacket packet29DestroyentityPacket)
+    {
+        handleInvalidPacket(packet29DestroyentityPacket);
+    }
+
+    public void handleSetPaintingMotive(SetPaintingArtPacket packet)
+    {
+        handleInvalidPacket(packet);
+    }
+
+    public void handlePickupSpawn(AddItemEntityPacket addItemEntityPacket21Pickupspawn)
+    {
+        handleInvalidPacket(addItemEntityPacket21Pickupspawn);
+    }
+
+    public void handleCollect(TakeItemEntityPacket takeItemEntityPacket)
+    {
+        handleInvalidPacket(takeItemEntityPacket);
+    }
+
+    public void handleChat(ChatPacket chatPacket)
+    {
+        handleInvalidPacket(chatPacket);
+    }
+
+    public void handleVehicleSpawn(AddEntityPacket addEntityPacket23Vehiclespawn)
+    {
+        handleInvalidPacket(addEntityPacket23Vehiclespawn);
+    }
+
+    public void handleAnimation(AnimatePacket animatePacket)
+    {
+        handleInvalidPacket(animatePacket);
+    }
+
+    public void handleEntityAction(PlayerCommandPacket packet19entityaction)
+    {
+        handleInvalidPacket(packet19entityaction);
+    }
+
+    public void handleHandshake(PreLoginPacket preLoginPacket)
+    {
+        handleInvalidPacket(preLoginPacket);
+    }
+
+    public void handleMobSpawn(AddMobPacket addMobspawn)
+    {
+        handleInvalidPacket(addMobspawn);
+    }
+
+    public void handleUpdateTime(SetTimePacket packet4UpdatetimePacket)
+    {
+        handleInvalidPacket(packet4UpdatetimePacket);
+    }
+
+    public void handleSpawnPosition(SetSpawnPositionPacket setSpawnpositionPacket)
+    {
+        handleInvalidPacket(setSpawnpositionPacket);
+    }
+
+    public void handleEntityVelocity(SetEntityMotionPacket setEntityvelocity)
+    {
+        handleInvalidPacket(setEntityvelocity);
+    }
+
+    public void handleEntityMetadata(SetEntityDataPacket entitymetadata)
+    {
+        handleInvalidPacket(entitymetadata);
+    }
+
+    public void handleAttachEntity(SetRidingPacket setRidingPacket39Attachentity)
+    {
+        handleInvalidPacket(setRidingPacket39Attachentity);
+    }
+
+    public void handleUseEntity(InteractPacket interactPacket7Useentity)
+    {
+        handleInvalidPacket(interactPacket7Useentity);
+    }
+
+    public void handleEntityStatus(EnitityEventPacket enitityEventPacket38Entitystatus)
+    {
+        handleInvalidPacket(enitityEventPacket38Entitystatus);
+    }
+
+    public void handleEntityTagData(EntityTagDataPacket packet)
+    {
+        handleInvalidPacket(packet);
+    }
+
+    public void handleUpdateHealth(SetHealthPacket packet8UpdatehealthPacket)
+    {
+        handleInvalidPacket(packet8UpdatehealthPacket);
+    }
+
+    public void handleUpdatePlayerProfile(UpdatePlayerProfilePacket updatePlayerProfilePacket)
+    {
+        handleInvalidPacket(updatePlayerProfilePacket);
+    }
+
+    public void handleRespawn(RespawnPacket respawnPacket)
+    {
+        handleInvalidPacket(respawnPacket);
+    }
+
+    public void handleExplosion(ExplosionPacket explosionPacket)
+    {
+        handleInvalidPacket(explosionPacket);
+    }
+
+    public void handleOpenWindow(ContainerOpenPacket containerOpenwindow)
+    {
+        handleInvalidPacket(containerOpenwindow);
+    }
+
+    public void handleCloseWindow(ContainerClosePacket containerClosewindow)
+    {
+        handleInvalidPacket(containerClosewindow);
+    }
+
+    public void handleWindowClick(ContainerClickPacket packet102WindowclickPacket)
+    {
+        handleInvalidPacket(packet102WindowclickPacket);
+    }
+
+    public void handleTileEntityData(BlockEntityDataPacket packet)
+    {
+        handleInvalidPacket(packet);
+    }
+
+    public void handleSetSlot(ContainerSetSlotPacket containerSetslotPacket)
+    {
+        handleInvalidPacket(containerSetslotPacket);
+    }
+
+    public void handleWindowItems(ContainerSetContentPacket containerSetContentPacket104Windowitems)
+    {
+        handleInvalidPacket(containerSetContentPacket104Windowitems);
+    }
+
+    public void handleUpdateSign(SignUpdatePacket packet130UpdatesignUpdatePacket)
+    {
+        handleInvalidPacket(packet130UpdatesignUpdatePacket);
+    }
+
+    public void handleSetMobSpawner(SetMobSpawnerPacket setMobSpawnerPacket)
+    {
+        handleInvalidPacket(setMobSpawnerPacket);
+    }
+    
+    public void handleUpdateProgressbar(ContainerSetDataPacket containerSetDataPacket105Updateprogressbar)
+    {
+        handleInvalidPacket(containerSetDataPacket105Updateprogressbar);
+    }
+
+    public void handlePlayerInventory(SetEquippedItemPacket setEquippedItemPacket5Playerinventory)
+    {
+        handleInvalidPacket(setEquippedItemPacket5Playerinventory);
+    }
+
+    public void handleTransaction(ContainerAckPacket containerAckPacket)
+    {
+        handleInvalidPacket(containerAckPacket);
+    }
+
+    public void handleEntityPainting(AddPaintingPacket packet25EntitypaintingPacket)
+    {
+        handleInvalidPacket(packet25EntitypaintingPacket);
+    }
+    public void handleBoatControl(BoatControlPacket boatControlPacket)
+    {
+        handleInvalidPacket(boatControlPacket);
+    }
+
+    public void handlePlayNoteBlock(BlockEventPacket packet54PlaynoteblockEventPacket)
+    {
+        handleInvalidPacket(packet54PlaynoteblockEventPacket);
+    }
+
+    public void handleStatistic(StatisticPacket statisticPacket)
+    {
+        handleInvalidPacket(statisticPacket);
+    }
+
+    public void handleSleep(SleepPacket sleepPacket)
+    {
+        handleInvalidPacket(sleepPacket);
+    }
+    public void handleBed(BedMessagePacket bedMessagePacket)
+    {
+        handleInvalidPacket(bedMessagePacket);
+    }
+
+    public void handleWeather(WeatherEffectPacket weatherEffectPacket)
+    {
+        handleInvalidPacket(weatherEffectPacket);
+    }
+
+    public void handleMapData(MapDataPacket mapdataPacket)
+    {
+        handleInvalidPacket(mapdataPacket);
+    }
+
+    public void handlePlaySoundEffect(PlaySoundEffectPacket packet61doorchange)
+    {
+        handleInvalidPacket(packet61doorchange);
+    }
+    public void handlePlaySoundDirectly(PlaySoundEffectDirectPacket playSoundEffectDirectPacket)
+    {
+        handleInvalidPacket(playSoundEffectDirectPacket);
+    }
+    public void handleSpawnParticle(AddParticlePacket addParticlePacket)
+    {
+        handleInvalidPacket(addParticlePacket);
+    }
+
+    public void handleEntityPlayerGamemode(PlayerGamemodePacket playerGamemodePacket)
+    {
+        handleInvalidPacket(playerGamemodePacket);
+    }
+
+    public void handleUpdateCreativeInventory(UpdateCreativeInventoryPacket updateCreativeInventoryPacket)
+    {
+        handleInvalidPacket(updateCreativeInventoryPacket);
+    }
+
+    public void handleWeatherStatus(WeatherStatusPacket weatherStatusPacket)
+    {
+        handleInvalidPacket(weatherStatusPacket);
+    }
+
+    public void handleOpenGuidebook(GuidebookPacket guidebookPacket)
+    {
+        handleInvalidPacket(guidebookPacket);
+    }
+
+    public void handleSetHotbarOffset(SetHotbarOffsetPacket setHotbarOffsetPacket)
+    {
+        handleInvalidPacket(setHotbarOffsetPacket);
+    }
+
+    public void handleEntityNickname(EntityNicknamePacket entityNicknamePacket)
+    {
+        handleInvalidPacket(entityNicknamePacket);
+    }
+
+    public void handleSendKey(AESSendKeyPacket AESSendKeyPacket)
+    {
+        handleInvalidPacket(AESSendKeyPacket);
+    }
+
+    public void handleItemName(SetItemNamePacket setItemNamePacket)
+    {
+        handleInvalidPacket(setItemNamePacket);
+    }
+    public void handlePlayerList(PlayerListPacket playerListPacket)
+    {
+        handleInvalidPacket(playerListPacket);
+    }
+
+    public void handleOpenFlagWindow(FlagOpenPacket packet)
+    {
+        handleInvalidPacket(packet);
+    }
+
+    public void handlePhotoMode(PhotoModePacket packet)
+    {
+        handleInvalidPacket(packet);
+    }
+
+    public void handlePingHandshake(PingHandshakePacket packet) {
+        handleInvalidPacket(packet);
+    }
+
+    public void handleGameRule(GameRulePacket gameRulePacket) {
+        handleInvalidPacket(gameRulePacket);
+    }
+
+    public void handleSyncedRecipe(RecipeSyncPacket recipeSyncPacket) {
+        handleInvalidPacket(recipeSyncPacket);
+    }
+    
+    public void handleIds(SyncIDsPacket packet) {
+    	handleInvalidPacket(packet);
+    }
+    
+    public void handleCustomPayload(CustomPayloadPacket packet) {
+    	handleInvalidPacket(packet);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet136SendKey.java b/src/main/java/net/minecraft/core/net/packet/AESSendKeyPacket.java
similarity index 55%
rename from src/main/java/net/minecraft/core/net/packet/Packet136SendKey.java
rename to src/main/java/net/minecraft/core/net/packet/AESSendKeyPacket.java
index 4b1cebc1a..c0027feda 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet136SendKey.java
+++ b/src/main/java/net/minecraft/core/net/packet/AESSendKeyPacket.java
@@ -1,49 +1,49 @@
 
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet136SendKey extends Packet
+public class AESSendKeyPacket extends Packet
 {
 
-    public Packet136SendKey()
+    public AESSendKeyPacket()
     {
     }
 
-    public Packet136SendKey(String KEY)
+    public AESSendKeyPacket(String KEY)
     {
         this.KEY = KEY;
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
             throws IOException
     {
         KEY = readString(dis, 344);
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
             throws IOException
     {
         writeString(KEY, dos);
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleSendKey(this);
+        packetHandler.handleSendKey(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 128;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java b/src/main/java/net/minecraft/core/net/packet/AddEntityPacket.java
similarity index 75%
rename from src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java
rename to src/main/java/net/minecraft/core/net/packet/AddEntityPacket.java
index 26008562e..4d3c990e0 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddEntityPacket.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.MathHelper;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-public class Packet23VehicleSpawn extends Packet {
+public class AddEntityPacket extends Packet {
     public int entityId;
     public int xPosition;
     public int yPosition;
@@ -22,18 +22,18 @@ public class Packet23VehicleSpawn extends Packet {
     public short type = -1;
     public int ownerId = -1;
     public int metaData = -1;
-    public Packet23VehicleSpawn() {}
-    public Packet23VehicleSpawn(Entity entity)
+    public AddEntityPacket() {}
+    public AddEntityPacket(Entity entity)
     {
         this(entity, -1, -1, null, null, null);
     }
-    public Packet23VehicleSpawn(Entity entity, int metaData){ this(entity, metaData, -1, null, null, null); }
-    public Packet23VehicleSpawn(Entity entity, int metaData, int ownerId){ this(entity, metaData, ownerId, null, null, null); }
-    public Packet23VehicleSpawn(Entity entity, int metaData, int ownerId, Double xVelocity, Double yVelocity, Double zVelocity) {
+    public AddEntityPacket(Entity entity, int metaData){ this(entity, metaData, -1, null, null, null); }
+    public AddEntityPacket(Entity entity, int metaData, int ownerId){ this(entity, metaData, ownerId, null, null, null); }
+    public AddEntityPacket(Entity entity, int metaData, int ownerId, Double xVelocity, Double yVelocity, Double zVelocity) {
         this.entityId = entity.id;
-        this.xPosition = MathHelper.floor_double(entity.x * 32D);
-        this.yPosition = MathHelper.floor_double(entity.y * 32D);
-        this.zPosition = MathHelper.floor_double(entity.z * 32D);
+        this.xPosition = MathHelper.floor(entity.x * 32D);
+        this.yPosition = MathHelper.floor(entity.y * 32D);
+        this.zPosition = MathHelper.floor(entity.z * 32D);
         this.pitch = entity.xRot;
         this.yaw = entity.yRot;
         this.metaData = metaData;
@@ -47,14 +47,14 @@ public class Packet23VehicleSpawn extends Packet {
             this.hasVelocity = false;
         }
     }
-    public Packet23VehicleSpawn setType(int type){
+    public AddEntityPacket setType(int type){
         this.type = (short) type;
         return this;
     }
 
 
     @Override
-	public void readPacketData(DataInputStream dis) throws IOException {
+	public void read(DataInputStream dis) throws IOException {
         entityId = dis.readInt();
         type = dis.readShort();
         xPosition = dis.readInt();
@@ -79,7 +79,7 @@ public class Packet23VehicleSpawn extends Packet {
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos) throws IOException {
+	public void write(DataOutputStream dos) throws IOException {
         dos.writeInt(entityId);
         dos.writeShort(type);
         dos.writeInt(xPosition);
@@ -126,13 +126,13 @@ public class Packet23VehicleSpawn extends Packet {
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleVehicleSpawn(this);
+        packetHandler.handleVehicleSpawn(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 21 + ownerId <= 0 ? 0 : 6;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet21PickupSpawn.java b/src/main/java/net/minecraft/core/net/packet/AddItemEntityPacket.java
similarity index 69%
rename from src/main/java/net/minecraft/core/net/packet/Packet21PickupSpawn.java
rename to src/main/java/net/minecraft/core/net/packet/AddItemEntityPacket.java
index 1bcbea2a4..c89b2c854 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet21PickupSpawn.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddItemEntityPacket.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.ItemEntity;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.MathHelper;
 
 import java.io.*;
 
-public class Packet21PickupSpawn extends Packet {
+public class AddItemEntityPacket extends Packet {
     public int entityId;
     public int xPosition;
     public int yPosition;
@@ -20,24 +20,24 @@ public class Packet21PickupSpawn extends Packet {
     public int itemDamage;
     public CompoundTag tag;
 
-    public Packet21PickupSpawn() {}
+    public AddItemEntityPacket() {}
 
-    public Packet21PickupSpawn(EntityItem entityitem) {
+    public AddItemEntityPacket(ItemEntity entityitem) {
         entityId = entityitem.id;
         itemID = entityitem.item.itemID;
         count = entityitem.item.stackSize;
         itemDamage = entityitem.item.getMetadata();
         tag = entityitem.item.getData();
-        xPosition = MathHelper.floor_double(entityitem.x * 32D);
-        yPosition = MathHelper.floor_double(entityitem.y * 32D);
-        zPosition = MathHelper.floor_double(entityitem.z * 32D);
+        xPosition = MathHelper.floor(entityitem.x * 32D);
+        yPosition = MathHelper.floor(entityitem.y * 32D);
+        zPosition = MathHelper.floor(entityitem.z * 32D);
         xd = (byte)(int)(entityitem.xd * 128D);
         yd = (byte)(int)(entityitem.yd * 128D);
         zd = (byte)(int)(entityitem.zd * 128D);
     }
 
     @Override
-	public void readPacketData(DataInputStream dis) throws IOException {
+	public void read(DataInputStream dis) throws IOException {
         entityId = dis.readInt();
         itemID = dis.readShort();
         count = dis.readByte();
@@ -52,7 +52,7 @@ public class Packet21PickupSpawn extends Packet {
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos) throws IOException {
+	public void write(DataOutputStream dos) throws IOException {
         dos.writeInt(entityId);
         dos.writeShort(itemID);
         dos.writeByte(count);
@@ -67,13 +67,13 @@ public class Packet21PickupSpawn extends Packet {
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handlePickupSpawn(this);
+        packetHandler.handlePickupSpawn(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 24;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet24MobSpawn.java b/src/main/java/net/minecraft/core/net/packet/AddMobPacket.java
similarity index 52%
rename from src/main/java/net/minecraft/core/net/packet/Packet24MobSpawn.java
rename to src/main/java/net/minecraft/core/net/packet/AddMobPacket.java
index 105329bb5..19bbec4b7 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet24MobSpawn.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddMobPacket.java
@@ -1,32 +1,43 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 import java.util.List;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, EntityLiving, EntityList, MathHelper, 
-//            DataWatcher, NetHandler
+//            Packet, Mob, EntityList, MathHelper,
+//            DataWatcher, PacketHandler
 
-public class Packet24MobSpawn extends Packet
+public class AddMobPacket extends Packet
 {
+    public int id;
+    public short type;
+    public int x;
+    public int y;
+    public int z;
+    public byte yaw;
+    public byte pitch;
+    private SynchedEntityData metaData;
+    private List<SynchedEntityData.DataItem<?>> unpackedData;
+    public String nickname;
+    public byte chatColor;
 
-    public Packet24MobSpawn()
+    public AddMobPacket()
     {
     }
 
-    public Packet24MobSpawn(EntityLiving entityliving)
+    public AddMobPacket(Mob entityliving)
     {
-        entityId = entityliving.id;
+        id = entityliving.id;
         type = (short) EntityDispatcher.getEntityID(entityliving);
-        xPosition = MathHelper.floor_double(entityliving.x * 32D);
-        yPosition = MathHelper.floor_double(entityliving.y * 32D);
-        zPosition = MathHelper.floor_double(entityliving.z * 32D);
+        x = MathHelper.floor(entityliving.x * 32D);
+        y = MathHelper.floor(entityliving.y * 32D);
+        z = MathHelper.floor(entityliving.z * 32D);
         yaw = (byte)(int)((entityliving.yRot * 256F) / 360F);
         pitch = (byte)(int)((entityliving.xRot * 256F) / 360F);
         metaData = entityliving.getEntityData();
@@ -35,30 +46,30 @@ public class Packet24MobSpawn extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
-        entityId = dis.readInt();
+        id = dis.readInt();
         type = dis.readShort();
-        xPosition = dis.readInt();
-        yPosition = dis.readInt();
-        zPosition = dis.readInt();
+        x = dis.readInt();
+        y = dis.readInt();
+        z = dis.readInt();
         yaw = dis.readByte();
         pitch = dis.readByte();
-        receivedMetadata = SynchedEntityData.unpack(dis);
+        unpackedData = SynchedEntityData.unpack(dis);
         nickname = readString(dis, 32);
         chatColor = dis.readByte();
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
-        dos.writeInt(entityId);
+        dos.writeInt(id);
         dos.writeShort(type);
-        dos.writeInt(xPosition);
-        dos.writeInt(yPosition);
-        dos.writeInt(zPosition);
+        dos.writeInt(x);
+        dos.writeInt(y);
+        dos.writeInt(z);
         dos.writeByte(yaw);
         dos.writeByte(pitch);
         metaData.packAll(dos);
@@ -67,31 +78,21 @@ public class Packet24MobSpawn extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleMobSpawn(this);
+        packetHandler.handleMobSpawn(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 21;
     }
 
-    public List getMetadata()
+    public List<SynchedEntityData.DataItem<?>> getUnpackedData()
     {
-        return receivedMetadata;
+        return unpackedData;
     }
 
-    public int entityId;
-    public short type;
-    public int xPosition;
-    public int yPosition;
-    public int zPosition;
-    public byte yaw;
-    public byte pitch;
-    private SynchedEntityData metaData;
-    private List receivedMetadata;
-    public String nickname;
-    public byte chatColor;
+
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet25EntityPainting.java b/src/main/java/net/minecraft/core/net/packet/AddPaintingPacket.java
similarity index 68%
rename from src/main/java/net/minecraft/core/net/packet/Packet25EntityPainting.java
rename to src/main/java/net/minecraft/core/net/packet/AddPaintingPacket.java
index 9357a5591..ae2ac326a 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet25EntityPainting.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddPaintingPacket.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.entity.EntityPainting;
+import net.minecraft.core.entity.PaintingEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, EntityPainting, ArtType, NetHandler
+//            Packet, PaintingEntity, ArtType, PacketHandler
 
-public class Packet25EntityPainting extends Packet
+public class AddPaintingPacket extends Packet
 {
 
-    public Packet25EntityPainting()
+    public AddPaintingPacket()
     {
     }
 
-    public Packet25EntityPainting(EntityPainting entitypainting)
+    public AddPaintingPacket(PaintingEntity entitypainting)
     {
         entityId = entitypainting.id;
-        xPosition = entitypainting.xPosition;
-        yPosition = entitypainting.yPosition;
-        zPosition = entitypainting.zPosition;
+        xPosition = entitypainting.blockX;
+        yPosition = entitypainting.blockY;
+        zPosition = entitypainting.blockZ;
         direction = entitypainting.direction;
         key = entitypainting.art.key;
         itemID = -1;
@@ -35,7 +35,7 @@ public class Packet25EntityPainting extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         entityId = dis.readInt();
@@ -49,7 +49,7 @@ public class Packet25EntityPainting extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(entityId);
@@ -63,13 +63,13 @@ public class Packet25EntityPainting extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleEntityPainting(this);
+        packetHandler.handleEntityPainting(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 24;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java b/src/main/java/net/minecraft/core/net/packet/AddParticlePacket.java
similarity index 69%
rename from src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java
rename to src/main/java/net/minecraft/core/net/packet/AddParticlePacket.java
index a239b82b5..914100b7c 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet63SpawnParticleEffect.java
+++ b/src/main/java/net/minecraft/core/net/packet/AddParticlePacket.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-public class Packet63SpawnParticleEffect extends Packet{
+public class AddParticlePacket extends Packet{
     public String particleKey;
     public double x;
     public double y;
@@ -25,24 +25,24 @@ public class Packet63SpawnParticleEffect extends Packet{
     public float randMotionY;
     public float randMotionZ;
 
-    public Packet63SpawnParticleEffect(){
+    public AddParticlePacket(){
 
     }
-    public Packet63SpawnParticleEffect(String particleKey, double x, double y, double z,
-                                       double motionX, double motionY, double motionZ, int data){
+    public AddParticlePacket(String particleKey, double x, double y, double z,
+                             double motionX, double motionY, double motionZ, int data){
         this(particleKey, x, y, z, motionX, motionY, motionZ, data, 16D);
     }
-    public Packet63SpawnParticleEffect(String particleKey, double x, double y, double z,
-                                       double motionX, double motionY, double motionZ, int data, double maxDistance){
+    public AddParticlePacket(String particleKey, double x, double y, double z,
+                             double motionX, double motionY, double motionZ, int data, double maxDistance){
         this(particleKey, x, y, z, motionX, motionY, motionZ, data,
                 maxDistance, (byte) -1, 0, 0, 0, 0, 0, 0);
 
     }
-    public Packet63SpawnParticleEffect(String particleKey, double x, double y, double z,
-                                       double motionX, double motionY, double motionZ,
-                                       int data, double maxDistance, byte amount, float randOffX,
-                                       float randOffY, float randOffZ, float randMotionX,
-                                       float randMotionY, float randMotionZ){
+    public AddParticlePacket(String particleKey, double x, double y, double z,
+                             double motionX, double motionY, double motionZ,
+                             int data, double maxDistance, byte amount, float randOffX,
+                             float randOffY, float randOffZ, float randMotionX,
+                             float randMotionY, float randMotionZ){
         this.particleKey = particleKey;
         this.x = x;
         this.y = y;
@@ -64,7 +64,7 @@ public class Packet63SpawnParticleEffect extends Packet{
         }
     }
     @Override
-    public void readPacketData(DataInputStream dis) throws IOException {
+    public void read(DataInputStream dis) throws IOException {
         this.particleKey = dis.readUTF();
         this.x = dis.readDouble();
         this.y = dis.readDouble();
@@ -88,7 +88,7 @@ public class Packet63SpawnParticleEffect extends Packet{
     }
 
     @Override
-    public void writePacketData(DataOutputStream dos) throws IOException {
+    public void write(DataOutputStream dos) throws IOException {
         dos.writeUTF(particleKey);
         dos.writeDouble(x);
         dos.writeDouble(y);
@@ -110,12 +110,12 @@ public class Packet63SpawnParticleEffect extends Packet{
     }
 
     @Override
-    public void processPacket(NetHandler netHandler) {
-        netHandler.handleSpawnParticle(this);
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleSpawnParticle(this);
     }
 
     @Override
-    public int getPacketSize() {
+    public int getEstimatedSize() {
         return 40;
     }
 }
